#!/usr/bin/python -u
import zlib
import sys
import time
import os
import pwd

from Crypto.Hash import SHA
from Crypto.Hash import SHA256
from Crypto import Random


def gen_rand_bytes(n):
	return Random.new().read(n)


salt_file = sys.argv[1]
f = open(salt_file, "r")
SALT = f.read()

def create_user():
	username = raw_input("Username=")
	if "Admin" in username:
		print "Heh, not so fast. Administration is not allowed for mere mortals"
	else:
		password = SALT + username
		password = SHA.new(password).hexdigest() + SHA256.new(password).hexdigest()
		print "Here's your password for user [%s]: [%s]. Keep it super safe!" % (username.encode('hex'), password)

def log_in():
	username = raw_input("Username=").decode('hex')
	password = raw_input("Password=").decode('hex')

	check = SALT + username
	check = SHA.new(check).digest() + SHA256.new(check).digest()

	if password == check:
		print "Password OK"
	else:
		print "Nope"
		exit(1)

	if "Admin" in username:
		print "Welcome Admin. Here's a flag for your trouble"
		with open(sys.argv[1], 'rt') as f:
			flag = f.read()
		print "The flag is: %s!" % flag
		exit(0)
	else:
		print "Nothing here yet :) Check back later"		


if __name__ == "__main__":
	print "Choose your destiny:"
	print "1. Create a user"
	print "2. Log into the secret vault"
	option = raw_input()
	if option == "1":
		create_user()
	elif option == "2":
		log_in()
	else:
		print "Not implemented"
